// 
// 8088 Corruption For Windows v2.0 - by Napalm
// Original Idea by Trixter
// 
// You can find example TMV files on:
// http://www.oldskool.org/pc/8088_Corruption
// 
// Untested on Linux WINE
// 
//

#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "gdi32.lib")
#pragma comment(lib, "comctl32.lib")
#define _WIN32_WINNT	0x0500
#define _WIN32_IE		0x0500
#include <windows.h>
#include <commctrl.h>
#include <math.h>
#include "resource.h"


HINSTANCE g_hInst;
HFONT g_hfWindings;
HBITMAP g_hbmBackground;
HMENU g_hMainMenu;
HANDLE g_hMovieFile;
DWORD g_dwMovieSize, g_dwMoviePos;
BOOL g_bOpen, g_bPlaying;
HANDLE g_hPlaying;

// Video Background Buffer
BITMAPINFO bmpBackInfo = { { sizeof(BITMAPINFOHEADER), 320, -200, 1, 32, BI_RGB, (320*200*4), 0, 0, 0, 0 } };
CRITICAL_SECTION csBackBuffer;
volatile LPDWORD pBackBuffer;
#define VIDEO_FRAME_SIZE	0x07D0

// Old CGA Font
extern BYTE bCGAFont8x8[2048];

// Old CGA Palette 4Bit (16 Colors)
DWORD dwCGAPalette[16] = {
	0x000000, 0x0000AA, 0x00AA00, 0x00AAAA,
	0xAA0000, 0xAA00AA, 0xAA5500, 0xAAAAAA,
	0x555555, 0x5555FF, 0x55FF55, 0x55FFFF,
	0xFF5555, 0xFF55FF, 0xFFFF55, 0xFFFFFF
};

// Audio Frame Synchronization
CRITICAL_SECTION csAudioFree;
volatile DWORD   dwAudioFree;

#include <pshpack1.h>
#define TMVSIGNATURE	0x56414D54
struct {
	DWORD dwSignature;
	WORD  wSampleRate;
	WORD  wChunkSize;
	BYTE  bCompMethod;
	BYTE  bCharCols;
	BYTE  bCharRows;
	BYTE  bVersion;
} TMVHeader;
#include <poppack.h>


// Allocate Audio Frames
LPWAVEHDR AudioAlloc(DWORD dwSize, int nFrameCount)
{
	DWORD dwAllocHeaderSize	= (sizeof(WAVEHDR) * nFrameCount);
	DWORD dwAllocFullSize	= ((dwSize * nFrameCount) + dwAllocHeaderSize);
	LPWAVEHDR lpFrames = (LPWAVEHDR) new BYTE[dwAllocFullSize];
	if(lpFrames == NULL) return NULL;
	ZeroMemory(lpFrames, dwAllocFullSize);
	
	LPSTR lpBuffer = (((LPSTR)lpFrames) + (sizeof(WAVEHDR) * nFrameCount));
	for(int nFrame = 0; nFrame < nFrameCount; nFrame++){
		lpFrames[nFrame].dwBufferLength	= dwSize;
		lpFrames[nFrame].lpData			= lpBuffer;
		lpBuffer += dwSize;
	}
	
	return lpFrames;
}

// Free Audio frame
void CALLBACK AudioProc(HWAVEOUT hWave, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)						 
{
	if(uMsg != WOM_DONE) return;
	EnterCriticalSection(&csAudioFree);
	dwAudioFree++;
	LeaveCriticalSection(&csAudioFree);
}

// Render Video frame
void RenderVector(LPDWORD pPixels, LPBYTE pVector, BYTE bVectorAttr, INT nStride)
{
    DWORD dwColors[2] = {
		dwCGAPalette[bVectorAttr >> 4],
		dwCGAPalette[bVectorAttr & 0x0F],
	};
	
	// Loop though the 8x8 Font data.
	// Depending on bit state we render foreground or background color.
    for(int nY = 0; nY < 8; nY++){
        BYTE bVector = *pVector++, bMask = 0x80;
        for(int nX = 0; nX < 8; nX++){
			*pPixels++ = dwColors[!(!(bVector & bMask))];
            bMask >>= 1;
        }
        pPixels += nStride - 8;
    }
}

void RenderFrame(LPWORD bVideoFrame)
{
	for(int y = 0; y < 8; y++){
		LPDWORD destdata = (((LPDWORD)pBackBuffer) + (y * 320));
		for(int i = 0; i < (40 * 25); i++){
			DWORD dwColors[2] = {
				dwCGAPalette[HIBYTE(bVideoFrame[i]) >> 4],
				dwCGAPalette[HIBYTE(bVideoFrame[i]) & 0x0F],
			};
			LPBYTE fontdata = &bCGAFont8x8[((LOBYTE(bVideoFrame[i]) * 8) + y)];
			for(int x = 0; x < 8; x++, destdata++){
				if(((*fontdata & (1 << (7 - x))) >> (7 - x)))
					 *destdata = dwColors[1];
				else *destdata = dwColors[0];
			}
		}
	}
	/*
	for(int i = 0; i < (40 * 25); i++){
		DWORD dwColors[2] = {
			dwCGAPalette[HIBYTE(bVideoFrame[i]) >> 4],
			dwCGAPalette[HIBYTE(bVideoFrame[i]) & 0x0F],
		};
		
		LPDWORD destdata = (&((LPDWORD)pBackBuffer)[((i * 8) * (i % 25))]);
		for(int y = 0; y < 8; y++){
			for(int x = 0; x < 8; x++, destdata++){
				if(((*fontdata & (1 << (7 - x))) >> (7 - x)))
					 *destdata = dwColors[1];
				else *destdata = dwColors[0];
			}
			destdata += (320 - 8);
			fontdata++;
		}
	}
	*/
}

// Output the Audio and Video frame data
DWORD CALLBACK PlayingThread(LPVOID lpParam)
{
	// Setup variables for playback.
	HWND hWnd = (HWND)lpParam;
	DWORD dwFrameSize = (VIDEO_FRAME_SIZE + TMVHeader.wChunkSize);
	DWORD dwFrameTotal = ((g_dwMovieSize - sizeof(TMVHeader)) / dwFrameSize);
	DWORD dwAudioCurr  = 0, dwVideoRead;
	BYTE bVideoFrame[VIDEO_FRAME_SIZE];

	SendMessage(GetDlgItem(hWnd, ID_POS), TBM_SETRANGEMAX, FALSE, dwFrameTotal);
	SendMessage(GetDlgItem(hWnd, ID_POS), TBM_SETPOS,       TRUE, 0);

	// Setup free frame counter.
	InitializeCriticalSection(&csAudioFree);
	dwAudioFree = 5;

	// Allocate a back buffer for audio frames.
	LPWAVEHDR pAudioFrames = AudioAlloc(TMVHeader.wChunkSize, 5);
	
	// Setup a format structure for audio output
	WAVEFORMATEX sWaveFormat    = { WAVE_FORMAT_PCM, 1, TMVHeader.wSampleRate, 0, 0, 8, sizeof(WAVEFORMATEX) };
	sWaveFormat.nBlockAlign     = ((sWaveFormat.nChannels * sWaveFormat.wBitsPerSample) / 8);
	sWaveFormat.nAvgBytesPerSec = (sWaveFormat.nBlockAlign * sWaveFormat.nSamplesPerSec);
	
	// Open up audio output for playback using specified format.
	HWAVEOUT hWaveOut;
	if(waveOutOpen(&hWaveOut, (UINT)WAVE_MAPPER, &sWaveFormat, (DWORD)AudioProc, 0, CALLBACK_FUNCTION) != MMSYSERR_NOERROR){
		DeleteCriticalSection(&csAudioFree);
		delete pAudioFrames;
		return 1;
	}

	// Start playback
	while(g_bOpen){
		LPWAVEHDR pAudioFrame = &pAudioFrames[dwAudioCurr];
		while(g_bOpen && (g_dwMoviePos < dwFrameTotal)){
			if(g_bPlaying){
				// Read in Video frame.
				SetFilePointer(g_hMovieFile, (sizeof(TMVHeader) + (g_dwMoviePos * dwFrameSize)), NULL, FILE_BEGIN);
				ReadFile(g_hMovieFile, bVideoFrame, VIDEO_FRAME_SIZE, &dwVideoRead, NULL);
				
				// Render Video frame.
				//EnterCriticalSection(&csBackBuffer);
				DWORD dwFrameIdx = 0;
				LPDWORD pPixels  = pBackBuffer;
				for(int nY = 0; nY < 25; nY++){
					for(int nX = 0; nX < 40; nX++, pPixels += 8){
						BYTE bVectorIdx  = bVideoFrame[dwFrameIdx++];
						BYTE bVectorAttr = bVideoFrame[dwFrameIdx++];
						RenderVector(pPixels, &bCGAFont8x8[bVectorIdx * 8], bVectorAttr, 320);
					}
					pPixels += (320 * 7);
				}
				//RenderFrame((LPWORD)&bVideoFrame);
				//LeaveCriticalSection(&csBackBuffer);

				// Unprepare this audio frame if it was previously used.
				if(pAudioFrame->dwFlags & WHDR_PREPARED) 
					waveOutUnprepareHeader(hWaveOut, pAudioFrame, sizeof(WAVEHDR));

				// Read in Audio frame.
				ReadFile(g_hMovieFile, pAudioFrame->lpData, TMVHeader.wChunkSize, &pAudioFrame->dwBufferLength, NULL);

				// Output Audio frame
				waveOutPrepareHeader(hWaveOut, pAudioFrame, sizeof(WAVEHDR));
				waveOutWrite(hWaveOut, pAudioFrame, sizeof(WAVEHDR));
				
				// Update free audio frame count.
				EnterCriticalSection(&csAudioFree);
				dwAudioFree--;
				LeaveCriticalSection(&csAudioFree);

				// Wait if none free.
				while(!dwAudioFree) Sleep(1);
				
				// Select next back buffer audio frame to use.
				dwAudioCurr = (++dwAudioCurr % 5);
				pAudioFrame = &pAudioFrames[dwAudioCurr];

				SendMessage(GetDlgItem(hWnd, ID_POS), TBM_SETPOS, TRUE, g_dwMoviePos);
				g_dwMoviePos++;
			}else{
				Sleep(1);
			}
		}
		SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_STOP, BN_CLICKED), 0);
	}

	// If still playing audio then wait.
	while(dwAudioFree < 5) Sleep(1);

	// Free up audio resources.
	waveOutClose(hWaveOut);
	DeleteCriticalSection(&csAudioFree);
	delete pAudioFrames;
	return 0;
}

HFONT MakeFont(LPSTR lpszFont, int nPointSize, int nWeight, BOOL bItalic, BOOL bUnderline, BOOL bStrikeOut, int nCharSet)
{
	HDC hDC = GetDC(HWND_DESKTOP);
	nPointSize = -MulDiv(nPointSize, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	ReleaseDC(HWND_DESKTOP, hDC);
	return CreateFont(nPointSize, 0, 0, 0, nWeight, bItalic, bUnderline, bStrikeOut, 
		nCharSet, OUT_STROKE_PRECIS, CLIP_STROKE_PRECIS, ANTIALIASED_QUALITY, FF_DONTCARE, lpszFont);
}

void EnableControls(HWND hWnd, BOOL bEnable)
{
	HMENU hMenu = GetMenu(hWnd);
	if(g_bPlaying) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_PLAY, BN_CLICKED), 0);
	EnableMenuItem(hMenu, ID_PLAY,  MF_BYCOMMAND | ((bEnable)?MF_ENABLED:MF_DISABLED | MF_GRAYED));
	EnableMenuItem(hMenu, ID_STOP,  MF_BYCOMMAND | ((bEnable)?MF_ENABLED:MF_DISABLED | MF_GRAYED));
	EnableMenuItem(hMenu, ID_CLOSE, MF_BYCOMMAND | ((bEnable)?MF_ENABLED:MF_DISABLED | MF_GRAYED));
	EnableWindow(GetDlgItem(hWnd, ID_PLAY), bEnable);
	EnableWindow(GetDlgItem(hWnd, ID_STOP), bEnable);
	EnableWindow(GetDlgItem(hWnd, ID_POS),  bEnable);
}

// Size Window
void SizeWindowByClient(HWND hWnd, int nWidth, int nHeight)
{
	RECT rcSize = { 0, 0, nWidth, (nHeight + 45) };
	AdjustWindowRectEx(&rcSize, WS_OVERLAPPEDWINDOW, TRUE, WS_EX_APPWINDOW);
	SetWindowPos(hWnd, NULL, 0, 0, (rcSize.right - rcSize.left),
		(rcSize.bottom - rcSize.top), SWP_NOMOVE | SWP_NOZORDER);
}

// About Dialog Handler
BOOL CALLBACK AboutDlgProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch(uMessage)
	{
		case WM_INITDIALOG:
			{
				RECT rcWindow, rcParent;
				GetWindowRect(hWnd, &rcWindow);
				GetWindowRect(GetParent(hWnd), &rcParent);
				SetWindowPos(hWnd, NULL,
					(rcParent.left + (((rcParent.right - rcParent.left) - (rcWindow.right - rcWindow.left)) / 2)),
					(rcParent.top  + (((rcParent.bottom - rcParent.top) - (rcWindow.bottom - rcWindow.top)) / 2)),
					0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			return TRUE;

		case WM_CLOSE:
			wParam = IDCANCEL;
		case WM_COMMAND:
			EndDialog(hWnd, LOWORD(wParam));
			return TRUE;
	}

	return FALSE;
}

// Window Handler
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
	switch(uMessage)
	{
		case WM_CREATE:
			g_hfWindings = MakeFont("Webdings", 20, FW_NORMAL, FALSE, FALSE, FALSE, SYMBOL_CHARSET);
			CreateWindow("Button", "4", BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
				0, 0, 25, 25, hWnd, (HMENU)ID_PLAY, g_hInst, NULL);
			CreateWindow("Button", "<", BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE,
				0, 0, 25, 25, hWnd, (HMENU)ID_STOP, g_hInst, NULL);
			CreateWindow("msctls_trackbar32", NULL, TBS_HORZ | TBS_BOTH | TBS_FIXEDLENGTH | TBS_NOTICKS | WS_CHILD | WS_VISIBLE,
				0, 0, 25, 25, hWnd, (HMENU)ID_POS, g_hInst, NULL);
			SendMessage(GetDlgItem(hWnd, ID_PLAY), WM_SETFONT, (WPARAM)g_hfWindings, FALSE);
			SendMessage(GetDlgItem(hWnd, ID_STOP), WM_SETFONT, (WPARAM)g_hfWindings, FALSE);
			SendMessage(GetDlgItem(hWnd, ID_POS), TBM_SETRANGEMIN, FALSE, 0);
			SendMessage(GetDlgItem(hWnd, ID_POS), TBM_SETRANGEMAX, FALSE, 0);
			SendMessage(GetDlgItem(hWnd, ID_POS), TBM_SETPOS,       TRUE, 0);
			g_hbmBackground = LoadBitmap(g_hInst, MAKEINTRESOURCE(IDB_BACKGROUND));
			g_hMainMenu = GetMenu(hWnd);
			g_hMovieFile = NULL;
			g_dwMovieSize = g_dwMoviePos = 0;
			g_bPlaying = g_bOpen = FALSE;
			g_hPlaying = NULL;
			EnableControls(hWnd, FALSE);
			return 0;

		case WM_TIMER: // Invalidate window to force re-paint.
			InvalidateRect(hWnd, NULL, FALSE);
			return 0;
			
		case WM_SIZE:
			{
				RECT rcClient = { 0, 0, (LOWORD(lParam) - 72), (HIWORD(lParam) - 37) };
				MoveWindow(GetDlgItem(hWnd, ID_PLAY), 10, rcClient.bottom, 25, 25, FALSE);
				MoveWindow(GetDlgItem(hWnd, ID_STOP), 45, rcClient.bottom, 25, 25, FALSE);
				MoveWindow(GetDlgItem(hWnd, ID_POS),  70, rcClient.bottom, rcClient.right, 25, FALSE);
				InvalidateRect(GetDlgItem(hWnd, ID_PLAY), NULL, FALSE);
				InvalidateRect(GetDlgItem(hWnd, ID_STOP), NULL, FALSE);
				InvalidateRect(GetDlgItem(hWnd, ID_POS), NULL, FALSE);
				InvalidateRect(hWnd, NULL, FALSE);
				UpdateWindow(hWnd);
			}
			return 0;

		case WM_GETMINMAXINFO:
			{
				LPMINMAXINFO lpInfo = (LPMINMAXINFO)lParam;
				lpInfo->ptMinTrackSize.x = 165;
				lpInfo->ptMinTrackSize.y = 185;
			}
			return 0;
			
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case ID_OPEN:
					{
						if(g_hMovieFile) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_CLOSE, BN_CLICKED), 0);
						
						CHAR szFile[MAX_PATH + 1]; *szFile = 0;
						OPENFILENAME openFile = { 
							sizeof(OPENFILENAME), hWnd, g_hInst,
							"TMV Movie Files(*.tmv)\0*.tmv\0All Files(*.*)\0*.*\0",
							NULL, 0, 0, szFile, MAX_PATH, NULL, 0, NULL,
							"Open Movie File...", OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST,
							0, 0, "*.tmv", 0, NULL, NULL,
						};
						
						if(GetOpenFileName(&openFile)){
							ZeroMemory(&TMVHeader, sizeof(TMVHeader));
							g_hMovieFile = CreateFile(szFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
							if(g_hMovieFile == INVALID_HANDLE_VALUE){
								MessageBox(hWnd, "Could not open file!", "Error", MB_ICONERROR | MB_OK);
							}else{
								DWORD dwHeaderRead;
								ReadFile(g_hMovieFile, &TMVHeader, sizeof(TMVHeader), &dwHeaderRead, NULL);
							}

							if((TMVHeader.dwSignature != TMVSIGNATURE) && (g_hMovieFile != INVALID_HANDLE_VALUE)){
								MessageBox(hWnd, "Not a valid TMV file!", "Error", MB_ICONERROR | MB_OK);
								CloseHandle(g_hMovieFile); g_hMovieFile = INVALID_HANDLE_VALUE;
							}
							if((TMVHeader.bCompMethod != 0) && (g_hMovieFile != INVALID_HANDLE_VALUE)){
								MessageBox(hWnd, "Unsupported compression method!", "Error", MB_ICONERROR | MB_OK);
								CloseHandle(g_hMovieFile); g_hMovieFile = INVALID_HANDLE_VALUE;
							}
							if((TMVHeader.bVersion != 0) && (g_hMovieFile != INVALID_HANDLE_VALUE)){
								MessageBox(hWnd, "Unsupported version!", "Error", MB_ICONERROR | MB_OK);
								CloseHandle(g_hMovieFile); g_hMovieFile = INVALID_HANDLE_VALUE;
							}
							if((TMVHeader.bCharCols != 40 || TMVHeader.bCharRows != 25) && (g_hMovieFile != INVALID_HANDLE_VALUE)){
								MessageBox(hWnd, "Unsupported resolution!", "Error", MB_ICONERROR | MB_OK);
								CloseHandle(g_hMovieFile); g_hMovieFile = INVALID_HANDLE_VALUE;
							}
							if(g_hMovieFile == INVALID_HANDLE_VALUE){
								g_hMovieFile = NULL;
								g_dwMovieSize = g_dwMoviePos = 0;
								SendDlgItemMessage(hWnd, ID_POS, TBM_SETPOS, TRUE, 0);
								return 0;
							}
							
							g_dwMovieSize = GetFileSize(g_hMovieFile, NULL);
							g_dwMoviePos = 0;
							SendDlgItemMessage(hWnd, ID_POS, TBM_SETPOS, TRUE, 0);
							EnableControls(hWnd, TRUE);
							
							// Create the playing thread.
							g_bOpen = TRUE;
							g_hPlaying = CreateThread(NULL, 0, PlayingThread, hWnd, 0, NULL);
							SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_PLAY, BN_CLICKED), 0);
						}
					}
					return  0;

				case ID_CLOSE:
					// If we are still playing terminate the thread.
					g_bOpen = FALSE;
					if(WaitForSingleObject(g_hPlaying, 2000) != WAIT_OBJECT_0)
						TerminateThread(g_hPlaying, 0);

					SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_STOP, BN_CLICKED), 0);
					EnableControls(hWnd, FALSE);
					
					EnterCriticalSection(&csBackBuffer);
					ZeroMemory(pBackBuffer, bmpBackInfo.bmiHeader.biSizeImage);
					LeaveCriticalSection(&csBackBuffer);
					
					if(g_hMovieFile){
						CloseHandle(g_hMovieFile);
						g_hMovieFile  = NULL;
						g_dwMovieSize = g_dwMoviePos = 0;
					}

					InvalidateRect(hWnd, NULL, FALSE);
					return 0;

				case ID_EXIT:
					DestroyWindow(hWnd);
					return 0;

				case ID_PLAY:
					if(g_bPlaying){
						SetDlgItemText(hWnd, ID_PLAY, "4");
						ModifyMenu(GetMenu(hWnd), ID_PLAY, MF_BYCOMMAND | MF_STRING, ID_PLAY, "&Play");
						KillTimer(hWnd, 0);
					}else{
						SetDlgItemText(hWnd, ID_PLAY, ";");
						ModifyMenu(GetMenu(hWnd), ID_PLAY, MF_BYCOMMAND | MF_STRING, ID_PLAY, "&Pause");
						SetTimer(hWnd, 0, (1000 / (TMVHeader.wSampleRate / TMVHeader.wChunkSize)), NULL);
					}
					g_bPlaying = !g_bPlaying;
					return 0;

				case ID_STOP:
					if(g_bPlaying) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_PLAY, BN_CLICKED), 0);
					g_dwMoviePos = 0;
					SendDlgItemMessage(hWnd, ID_POS, TBM_SETPOS, TRUE, 0);
					return 0;

				case ID_ZOOM50:  SizeWindowByClient(hWnd, 160, 100); return 0;
				case ID_ZOOM100: SizeWindowByClient(hWnd, 320, 200); return 0;
				case ID_ZOOM200: SizeWindowByClient(hWnd, 640, 400); return 0;

				case ID_FULLSCREEN:
					{
						BOOL bWasPlaying = g_bPlaying;
						if(bWasPlaying) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_PLAY, BN_CLICKED), 0);
						if(GetMenu(hWnd) != NULL){
							SetMenu(hWnd, NULL);
							SetWindowLong(hWnd, GWL_STYLE, WS_POPUP | WS_VISIBLE);
							ShowWindow(hWnd, SW_MAXIMIZE);
							SetForegroundWindow(hWnd);
						}else{
							ShowWindow(hWnd, SW_RESTORE);
							SetWindowLong(hWnd, GWL_STYLE, WS_OVERLAPPEDWINDOW | WS_VISIBLE);
							SetMenu(hWnd, g_hMainMenu);
						}
						if(bWasPlaying) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_PLAY, BN_CLICKED), 0);
					}
					return 0;

				case ID_ABOUT:
					if(DialogBox(g_hInst, MAKEINTRESOURCE(IDD_ABOUT), hWnd, AboutDlgProc) == IDOK)
						ShellExecute(hWnd, "open", "http://www.oldskool.org/pc/8088_Corruption", NULL, NULL, SW_SHOWDEFAULT);
					return 0;
					
			}
			break;

		case WM_LBUTTONDBLCLK:
			SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_FULLSCREEN, BN_CLICKED), 0);
			return 0;

		case WM_LBUTTONUP:
			// Needs fixing regarding double click
			//if(g_hMovieFile) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_PLAY, BN_CLICKED), 0);
			return 0;

		case WM_HSCROLL:
			{
				if((LOWORD(wParam) == SB_THUMBTRACK) || (LOWORD(wParam) == SB_THUMBPOSITION)){
					if(GetDlgCtrlID((HWND)lParam) == ID_POS)
					{
						g_dwMoviePos = SendMessage((HWND)lParam, TBM_GETPOS, 0, 0);
						return TRUE;
					}
				}
			}
			break;
			
		case WM_PAINT:
			{
				PAINTSTRUCT ps;
				if(BeginPaint(hWnd, &ps)){
					RECT rcClient; GetClientRect(hWnd, &rcClient);
					if(rcClient.bottom < 200 || rcClient.right < 320)
						SetStretchBltMode(ps.hdc, HALFTONE); // Anti-Alias the StretchDIBits/StretchBlt
					rcClient.bottom -= 45;
					if(g_hMovieFile){
						//EnterCriticalSection(&csBackBuffer);
						StretchDIBits(ps.hdc, 0, 0, rcClient.right, rcClient.bottom,
							0, 0, 320, 200, (LPVOID)pBackBuffer, &bmpBackInfo, DIB_RGB_COLORS, SRCCOPY);
						//LeaveCriticalSection(&csBackBuffer);
					}else{
						HDC hdcBackground = CreateCompatibleDC(ps.hdc);
						HBITMAP hbmOld = (HBITMAP)SelectObject(hdcBackground, g_hbmBackground);
						StretchBlt(ps.hdc, 0, 0, rcClient.right, rcClient.bottom,
							hdcBackground, 0, 0, 320, 200, SRCCOPY);
						SelectObject(hdcBackground, hbmOld);
						DeleteDC(hdcBackground);
					}
					rcClient.top = rcClient.bottom; rcClient.bottom += 45;
					DrawEdge(ps.hdc, &rcClient, EDGE_SUNKEN, BF_RECT | BF_MIDDLE | BF_FLAT);
					EndPaint(hWnd, &ps);
				}	
			}
			return 0;
			
		case WM_ERASEBKGND: // Stops flickering
			return 0;

		case WM_CLOSE:
			DestroyWindow(hWnd);
			return 0;

		case WM_DESTROY:
			if(g_hMovieFile) SendMessage(hWnd, WM_COMMAND, MAKELONG(ID_CLOSE, BN_CLICKED), 0);
			DeleteObject(g_hbmBackground);
			DestroyWindow(GetDlgItem(hWnd, ID_POS));
			DestroyWindow(GetDlgItem(hWnd, ID_STOP));
			DestroyWindow(GetDlgItem(hWnd, ID_PLAY));
			DeleteObject(g_hfWindings);
			PostQuitMessage(0);
			return 0;

	}
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

// Entry Point
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmdLine, int nShowCmd)
{
	g_hInst = hInstance;
	InitCommonControls();
	
	// Setup a window class and create the window to display the video
	RECT rcSize = { 0, 0, 320, 245 };
	AdjustWindowRectEx(&rcSize, WS_OVERLAPPEDWINDOW, TRUE, WS_EX_APPWINDOW | WS_EX_CONTROLPARENT);
	WNDCLASSEX wcexClass = {
		sizeof(WNDCLASSEX), CS_DBLCLKS, WndProc, 0, 0, g_hInst,
		LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_MAIN)), LoadCursor(NULL, IDC_ARROW),
		(HBRUSH)GetStockObject(BLACK_BRUSH), MAKEINTRESOURCE(IDR_MENU), "8088tmv"
	};
	if(!RegisterClassEx(&wcexClass)){
		MessageBox(HWND_DESKTOP, "Could not register class!", "Error", MB_ICONERROR | MB_OK);
		return 0;
	}
	int nXPos = ((GetSystemMetrics(SM_CXSCREEN) - rcSize.right)  / 2),
		nYPos = ((GetSystemMetrics(SM_CYSCREEN) - rcSize.bottom) / 2);
	HWND hWnd = CreateWindowEx(WS_EX_APPWINDOW | WS_EX_CONTROLPARENT, "8088tmv",
		"8088 Corruption for Windows v2.0 - by Napalm", WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
		nXPos, nYPos, (rcSize.right - rcSize.left), (rcSize.bottom - rcSize.top),
		HWND_DESKTOP, NULL, g_hInst, NULL);
	if(!hWnd){
		MessageBox(HWND_DESKTOP, "Could not create window!", "Error", MB_ICONERROR | MB_OK);
		return 0;
	}

	// Create a background buffer for the playing thread to render to.
	InitializeCriticalSection(&csBackBuffer);
	pBackBuffer = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (320 * 200 * 4));
	
	// Display the window.
	ShowWindow(hWnd, nShowCmd);
	UpdateWindow(hWnd);

	// Pump for messages.
	MSG msg;
	while(GetMessage(&msg, 0, 0, 0) != 0){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// Free the back buffer.
	DeleteCriticalSection(&csBackBuffer);
	HeapFree(GetProcessHeap(), 0, pBackBuffer);

	return (int)msg.wParam;
}
